﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;
using System.Windows.Forms;

namespace Glass
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public Boolean BEdit1 = false;
        public Boolean BEdit2 = false;


        int Nm;//構成ガラス種類数
        int Ng;//定数表ガラス数
        int NL;//波長分割数
        double Lam1;//波長初期値
        double Lam2;//波長終了値
        double Psi0;//目標パワー
        int Nr;//曲率変化種類数

        int[] Gn;//ガラスNo
        double[] aR;//曲率半径
        double[] A1, A2, A3, B1, B2, B3;//定数
        double[] Df;//各波長のフォーカス誤差(mm)

        double MinAR;　//負曲率制限値(1/mm)


        //連立方程式
        int Mn;//連立数を設定します。
        double[,] MA;//=new double[101,101];//[101][101];//M[i][j]=Aijの値を設定します。i=行、j=列
        double[] MB;//=new double[101];//[101];//MB[i]=Biの値を設定します。i=行
        double[] MX;//=new double[101];//[101];//MX[j]=Xjの値が格納されます。j=列


        //ガウス
        double SE;//誤差自乗和
        double NE;//評価数カウンタ
        double E;//誤差標準偏差値
        double DF;//フォーカス誤差
        double h=1E-7; //偏微分を行う際の変化量を設定
        int RN = 5;//収束演算繰り返し回数
        int MinGn;//誤差最小ガラスNo1
        int MinGn2;//誤差最小ガラスNo2
        double MinSE = 10000;//誤差最小値
        double[] MinDf;//Min各波長のフォーカス誤差(mm)




        public MainWindow()
        {
            InitializeComponent();
            myControl.UC = this;
            myControl.SetUC();
            myControl2.UC2 = this;
            myControl2.SetUC2();
        }

        

       

        private void MenuItem2_2_Click(object sender, RoutedEventArgs e)
        {
            int i,j,k;
             MinSE = 10000;//誤差最小値

            if (BEdit1 || BEdit2)
            {
                System.Windows.MessageBox.Show("dataGridView1が編集中です！！");
            }
            else
            {

                IN_DATA();


                double[] AR = new double[Nm + 1];

                var win = new Window1();
                win.myControl3.dataGridView1.ColumnCount =Nm+ 4;
                win.myControl3.dataGridView1.RowCount = Ng + 11 + NL;
                win.Show();

                win.myControl3.dataGridView1.Rows[0].Cells[0].Value = "評価結果";
                win.myControl3.dataGridView1.Rows[0].Cells[1].Value = "1";
                win.myControl3.dataGridView1.Rows[1].Cells[0].Value = "定数表ガラス数";
                win.myControl3.dataGridView1.Rows[1].Cells[1].Value = Convert.ToString(Ng);
                win.myControl3.dataGridView1.Rows[1].Cells[2].Value = "波長分割数";
                win.myControl3.dataGridView1.Rows[1].Cells[3].Value = Convert.ToString(NL);



                win.myControl3.dataGridView1.Rows[2].Cells[0].Value = "No";
                win.myControl3.dataGridView1.Rows[2].Cells[1].Value = "ガラス型名";
                win.myControl3.dataGridView1.Rows[2].Cells[2].Value = "focus誤差";
                win.myControl3.dataGridView1.Rows[3].Cells[0].Value = "整数";
                win.myControl3.dataGridView1.Rows[3].Cells[1].Value = "記号";
                win.myControl3.dataGridView1.Rows[3].Cells[2].Value = "mm";
                for (i = 1; i <= Nm; i++)
                {
                    win.myControl3.dataGridView1.Rows[2].Cells[2+i].Value = "aR["+ Convert.ToString(i) + "]";
                    win.myControl3.dataGridView1.Rows[3].Cells[2 + i].Value = "1/mm";
                }

                for (k = 1; k <= Ng; k++)
                {
                    //Gn[1] = k;
                    A1[1] = Convert.ToDouble(myControl2.dataGridView1.Rows[k - 1].Cells[2].Value);
                    A2[1] = Convert.ToDouble(myControl2.dataGridView1.Rows[k - 1].Cells[3].Value);
                    A3[1] = Convert.ToDouble(myControl2.dataGridView1.Rows[k - 1].Cells[4].Value);
                    B1[1] = Convert.ToDouble(myControl2.dataGridView1.Rows[k - 1].Cells[5].Value);
                    B2[1] = Convert.ToDouble(myControl2.dataGridView1.Rows[k - 1].Cells[6].Value);
                    B3[1] = Convert.ToDouble(myControl2.dataGridView1.Rows[k - 1].Cells[7].Value);
                    for (i = 1; i <= Nm; i++)
                    {
                        AR[i] = aR[i];//レンズ曲率(1/R)をコピー
                    }


                    for (i = 1; i <= RN; i++)
                    {
                        CAL_DP(AR);
                        for (j = 1; j <= Nr; j++)
                        {
                            AR[j] = AR[j] + MX[j];
                        }
                    }

                    bool ff = true;
                    for (j = 1; j <= Nr; j++)
                    {
                        if (AR[j] < MinAR) { ff = false; }
                    }

                    if (ff)
                    {
                        if (SE < MinSE)
                        {
                            MinSE = SE;
                            MinGn = k;

                            for (i = 0; i <= NL; i++)
                            {
                                MinDf[i] = Df[i];
                            }
                        }
                    }

                    win.myControl3.dataGridView1.Rows[3 + k].Cells[0].Value = Convert.ToString(k);
                    win.myControl3.dataGridView1.Rows[3 + k].Cells[1].Value = myControl2.dataGridView1.Rows[k - 1].Cells[1].Value;
                    win.myControl3.dataGridView1.Rows[3 + k].Cells[2].Value = Convert.ToString((float)DF);
                    for (i = 1; i <= Nm; i++)
                    {
                        win.myControl3.dataGridView1.Rows[3+k].Cells[2 + i].Value = Convert.ToString((float)AR[i]);
                    }

                    




                }
                win.myControl3.dataGridView1.Rows[5 + Ng].Cells[0].Value = "ガラスNo";
                win.myControl3.dataGridView1.Rows[5 + Ng].Cells[1].Value = Convert.ToString(MinGn);
                win.myControl3.dataGridView1.Rows[6 + Ng].Cells[0].Value = "ガラス型名";
                win.myControl3.dataGridView1.Rows[6 + Ng].Cells[1].Value = myControl2.dataGridView1.Rows[MinGn - 1].Cells[1].Value;
                win.myControl3.dataGridView1.Rows[7 + Ng].Cells[0].Value = "波長(μm)";
                win.myControl3.dataGridView1.Rows[7 + Ng].Cells[1].Value = "focus(mm)";

                double dLam = (Lam2 - Lam1) / NL;
                for (i = 0; i <= NL; i++)
                {
                    double Lam = Lam1 + dLam * i;
                    win.myControl3.dataGridView1.Rows[8 + Ng + i].Cells[0].Value = Convert.ToString((float)Lam);
                    win.myControl3.dataGridView1.Rows[8 + Ng + i].Cells[1].Value = Convert.ToString((float)MinDf[i]);
                }
            }
        }


        private void MenuItem2_3_Click(object sender, RoutedEventArgs e)
        {
            int i, j;
            MinSE = 10000;//誤差最小値

            if (BEdit1 || BEdit2)
            {
                System.Windows.MessageBox.Show("dataGridView1が編集中です！！");
            }
            else
            {

                IN_DATA();


                double[] AR = new double[Nm + 1];

                var win = new Window1();
                win.myControl3.dataGridView1.ColumnCount = Nm + 4;
                win.myControl3.dataGridView1.RowCount = Ng + 5;
                win.Show();

                win.myControl3.dataGridView1.Rows[0].Cells[0].Value = "評価結果";
                win.myControl3.dataGridView1.Rows[0].Cells[1].Value = "2";
                win.myControl3.dataGridView1.Rows[0].Cells[2].Value = "波長分割数";
                win.myControl3.dataGridView1.Rows[0].Cells[3].Value = Convert.ToString(NL);

                win.myControl3.dataGridView1.Rows[1].Cells[0].Value = "No";
                win.myControl3.dataGridView1.Rows[1].Cells[1].Value = "ガラス型名";
                win.myControl3.dataGridView1.Rows[1].Cells[2].Value = "focus誤差";
                win.myControl3.dataGridView1.Rows[2].Cells[0].Value = "整数";
                win.myControl3.dataGridView1.Rows[2].Cells[1].Value = "記号";
                win.myControl3.dataGridView1.Rows[2].Cells[2].Value = "mm";
                for (i = 1; i <= Nm; i++)
                {
                    win.myControl3.dataGridView1.Rows[1].Cells[2 + i].Value = "aR[" + Convert.ToString(i) + "]";
                    win.myControl3.dataGridView1.Rows[2].Cells[2 + i].Value = "1/mm";
                }

                for (i = 1; i <= Nm; i++)
                {
                    AR[i] = aR[i];//レンズ曲率(1/R)をコピー
                }


                for (i = 1; i <= RN; i++)
                {
                    CAL_DP(AR);
                    for (j = 1; j <= Nr; j++)
                    {
                        AR[j] = AR[j] + MX[j];
                    }
                }

                win.myControl3.dataGridView1.Rows[3].Cells[0].Value = Convert.ToString(Gn[1]);
                win.myControl3.dataGridView1.Rows[3].Cells[1].Value = myControl2.dataGridView1.Rows[Gn[1] - 1].Cells[1].Value;
                win.myControl3.dataGridView1.Rows[3].Cells[2].Value = Convert.ToString((float)DF);
                for (i = 1; i <= Nm; i++)
                {
                    win.myControl3.dataGridView1.Rows[3].Cells[2 + i].Value = Convert.ToString((float)AR[i]);
                }

                win.myControl3.dataGridView1.Rows[5].Cells[0].Value = "各波長focus";
                win.myControl3.dataGridView1.Rows[6].Cells[0].Value = "波長(μm)";
                win.myControl3.dataGridView1.Rows[6].Cells[1].Value = "focus(mm)";
                double dLam = (Lam2 - Lam1) / NL;

                for (i = 0; i <= NL; i++)
                {
                    double Lam = Lam1 + dLam * i;
                    win.myControl3.dataGridView1.Rows[7 + i].Cells[0].Value = Convert.ToString((float)Lam);
                    win.myControl3.dataGridView1.Rows[7 + i].Cells[1].Value = Convert.ToString((float)Df[i]);
                }


            }

        }


        private void MenuItem2_4_Click(object sender, RoutedEventArgs e)
        {
            int i, j,k,k2;
             MinSE = 10000;//誤差最小値
             double BestDF=0;
             

             if (BEdit1 || BEdit2)
             {
                 System.Windows.MessageBox.Show("dataGridView1が編集中です！！");
             }
             else
             {

                 IN_DATA();


                 double[] AR = new double[Nm + 1];
                 double[] BestAR = new double[Nm + 1];
                 

                 var win = new Window1();
                 win.myControl3.dataGridView1.ColumnCount = Nm + 6;
                 win.myControl3.dataGridView1.RowCount = Ng + 5;
                 win.Show();

                 

                 for (k2 = 1; k2 <= Ng; k2++)
                 {
                     A1[2] = Convert.ToDouble(myControl2.dataGridView1.Rows[k2 - 1].Cells[2].Value);
                     A2[2] = Convert.ToDouble(myControl2.dataGridView1.Rows[k2 - 1].Cells[3].Value);
                     A3[2] = Convert.ToDouble(myControl2.dataGridView1.Rows[k2 - 1].Cells[4].Value);
                     B1[2] = Convert.ToDouble(myControl2.dataGridView1.Rows[k2 - 1].Cells[5].Value);
                     B2[2] = Convert.ToDouble(myControl2.dataGridView1.Rows[k2 - 1].Cells[6].Value);
                     B3[2] = Convert.ToDouble(myControl2.dataGridView1.Rows[k2 - 1].Cells[7].Value);
                     for (k = 1; k <= Ng; k++)
                     {
                         //Gn[1] = k;
                         A1[1] = Convert.ToDouble(myControl2.dataGridView1.Rows[k - 1].Cells[2].Value);
                         A2[1] = Convert.ToDouble(myControl2.dataGridView1.Rows[k - 1].Cells[3].Value);
                         A3[1] = Convert.ToDouble(myControl2.dataGridView1.Rows[k - 1].Cells[4].Value);
                         B1[1] = Convert.ToDouble(myControl2.dataGridView1.Rows[k - 1].Cells[5].Value);
                         B2[1] = Convert.ToDouble(myControl2.dataGridView1.Rows[k - 1].Cells[6].Value);
                         B3[1] = Convert.ToDouble(myControl2.dataGridView1.Rows[k - 1].Cells[7].Value);
                         for (i = 1; i <= Nm; i++)
                         {
                             AR[i] = aR[i];//レンズ曲率(1/R)をコピー
                         }

                         for (i = 1; i <= RN; i++)
                         {
                             CAL_DP(AR);
                             for (j = 1; j <= Nr; j++)
                             {
                                 AR[j] = AR[j] + MX[j];
                             }
                         }

                         bool ff = true;
                         for (j = 1; j <= Nr; j++)
                         {
                             if (AR[j] < MinAR) { ff = false; }
                         }

                         if (ff)
                         {
                             if (SE < MinSE)
                             {
                                 MinSE = SE;
                                 MinGn = k;
                                 MinGn2 = k2;
                                 BestDF = DF;

                                 for (i = 0; i <= NL; i++)
                                 {
                                     MinDf[i] = Df[i];
                                 }
                                 for (j = 1; j <= Nm; j++)
                                 {
                                     BestAR[j] = AR[j];
                                 }
                             }
                         }
                     }
                 }


                 win.myControl3.dataGridView1.Rows[0].Cells[0].Value = "評価結果";
                 win.myControl3.dataGridView1.Rows[0].Cells[1].Value = "3";
                 win.myControl3.dataGridView1.Rows[0].Cells[2].Value = "波長分割数";
                 win.myControl3.dataGridView1.Rows[0].Cells[3].Value = Convert.ToString(NL);


                 win.myControl3.dataGridView1.Rows[1].Cells[0].Value = "focus標準偏差";
                 win.myControl3.dataGridView1.Rows[1].Cells[1].Value = Convert.ToString((float)BestDF);


                 win.myControl3.dataGridView1.Rows[2].Cells[0].Value = "No";
                 win.myControl3.dataGridView1.Rows[3].Cells[0].Value = "ガラス型名";
                 win.myControl3.dataGridView1.Rows[4].Cells[0].Value = "曲率(1/mm)";
                 win.myControl3.dataGridView1.Rows[2].Cells[1].Value = Convert.ToString(MinGn);
                 win.myControl3.dataGridView1.Rows[3].Cells[1].Value = myControl2.dataGridView1.Rows[MinGn - 1].Cells[1].Value;
                 win.myControl3.dataGridView1.Rows[4].Cells[1].Value = Convert.ToString((float)BestAR[1]);

                 win.myControl3.dataGridView1.Rows[2].Cells[2].Value = Convert.ToString(MinGn2);
                 win.myControl3.dataGridView1.Rows[3].Cells[2].Value = myControl2.dataGridView1.Rows[MinGn2 - 1].Cells[1].Value;
                 win.myControl3.dataGridView1.Rows[4].Cells[2].Value = Convert.ToString((float)BestAR[2]);

                 for (i = 3; i <= Nm; i++)
                 {
                     win.myControl3.dataGridView1.Rows[2].Cells[i].Value = Convert.ToString(Gn[i]);
                     win.myControl3.dataGridView1.Rows[3].Cells[i].Value = myControl2.dataGridView1.Rows[Gn[i] - 1].Cells[1].Value;
                     win.myControl3.dataGridView1.Rows[4].Cells[i].Value = Convert.ToString((float)BestAR[i]);
                 }



                 win.myControl3.dataGridView1.Rows[5].Cells[0].Value = "各波長focus";
                 win.myControl3.dataGridView1.Rows[6].Cells[0].Value = "波長(μm)";
                 win.myControl3.dataGridView1.Rows[6].Cells[1].Value = "focus(mm)";
                 double dLam = (Lam2 - Lam1) / NL;

                 for (i = 0; i <= NL; i++)
                 {
                     double Lam = Lam1 + dLam * i;
                     win.myControl3.dataGridView1.Rows[7 + i].Cells[0].Value = Convert.ToString((float)Lam);
                     win.myControl3.dataGridView1.Rows[7 + i].Cells[1].Value = Convert.ToString((float)MinDf[i]);
                 }



             }


        }

        void CAL_DP( double[] AR)
        {
            int i, j;
            double Sim, Sic, Sip;
            double[] SP = new double[Nr + 1];

   

            double dLam = (Lam2 - Lam1) / NL;

            for (i = 0; i <= Nr; i++)//N連の連立方程式の定数初期化
            {
                for (j = 1; j <= Nr; j++)
                {
                    MA[i, j] = 0;
                }
                MB[i] = 0;
            }

            NE = 0; SE = 0;
            for (i = 0; i <= NL; i++)
            {
                double Lam = Lam1 + dLam * i;
                Sic = Si(Lam,AR);
                Df[i] = 1 / Psi0 - 1 / (Psi0 + Sic);//各波長でのフォーカス誤差
                for (j = 1; j <= Nr; j++)
                {
                    AR[j] = AR[j] - h;
                    Sim = Si(Lam,AR);
                    AR[j] = AR[j] + 2 * h;
                    Sip = Si(Lam,AR);
                    AR[j] = AR[j] - h;
                    SP[j] = (Sip - Sim) / (2 * h);//偏微分
                }

                int ik, jk;

                for (ik = 1; ik <= Nr; ik++)//連立方程式の定数の加算処理
                {
                    for (jk = 1; jk <= Nr; jk++)
                    {
                        MA[ik, jk] = MA[ik, jk] + SP[jk ] * SP[ik];
                    }
                    MB[ik] = MB[ik] - Sic * SP[ik ];
                }
                NE = NE + 1 ;//評価数の加算処理
                SE = SE + Sic * Sic;//誤差の自乗和
            }

            CAL_MX();//連立方程式の解を求める
            E = Math.Sqrt(SE /NE);//誤差量の標準偏差
            DF = 1 / Psi0 - 1 / (Psi0 + E);//フォーカス誤差
        }


        double Si(double Lam,double[] AR)
        {
            int j;
            double Si = -Psi0;
            double[] Nf = new double[Nm + 1];

            for (j = 1; j <= Nm; j++)
            {
                Si = Si+FN(j, Lam) * AR[j];
            }

            return Si;
        }

        double FN(int j, double Lam)
        {
            

            double NN=(A1[j]*Lam*Lam)/(Lam*Lam-B1[j])+(A2[j]*Lam*Lam)/(Lam*Lam-B2[j])+(A3[j]*Lam*Lam)/(Lam*Lam-B3[j])+1;
            double Nf = Math.Sqrt(NN)-1;

            return Nf;
        }

        //連立方程式の解を求めるルーチン
        void CAL_MX()
        {
            int i, j, k;
            double Akk, Aik, SX;

            for (k = 1; k <= Mn; k++)//Aij消去操作の繰り返し
            {
                for (i = k + 1; i <= Mn; i++)//連立数分の繰り返し計算
                {
                    Akk = MA[k, k];
                    Aik = MA[i, k];
                    MB[i] = MB[i] * Akk - Aik * MB[k];//(4-b)式の計算
                    for (j = 1; j <= Mn; j++)
                    {//(4-1)～(4-n)式の計算
                        MA[i, j] = MA[i, j] * Akk - Aik * MA[k, j];
                    }
                }
            }

            MX[Mn] = MB[Mn] / MA[Mn, Mn];//(7)式の計算
            for (k = Mn - 1; k >= 1; k--)//Xjを求める計算の繰り返し
            {
                SX = 0;
                for (j = k + 1; j <= Mn; j++)
                {
                    SX = SX + MA[k, j] * MX[j];
                }
                MX[k] = (MB[k] - SX) / MA[k, k];//Xjを求める計算
            }
        }





        void IN_DATA()
        {
            int  j;


            Nm = Convert.ToInt32(TextBox1.Text);//構成ガラス種類
            Ng = Convert.ToInt32(TextBox2.Text);//定数表ガラス数
            NL = Convert.ToInt32(TextBox3.Text);//波長分割数
            Lam1 = Convert.ToDouble(TextBox4.Text);//波長初期値
            Lam2 = Convert.ToDouble(TextBox5.Text);//波長終了値
            Psi0 = Convert.ToDouble(TextBox6.Text);//目標パワー
            Nr = Convert.ToInt32(TextBox7.Text);//曲率変化種類数
            MinAR =Convert.ToDouble(TextBox8.Text);;　//負曲率制限値(1/mm)


            Gn = new Int32[Nm + 1];
            aR = new double[Nm + 1];
            A1 = new double[Nm + 1]; A2 = new double[ Nm + 1]; A3 = new double[ Nm + 1];
            B1 = new double[ Nm + 1]; B2 = new double[ Nm + 1]; B3 = new double[Nm + 1];

            Mn = Nr;
            MA = new double[Mn+1, Mn+1];
            MB = new double[Mn + 1];
            MX = new double[Mn + 1];

            Df = new double[NL + 1];//各波長でのフォーカス誤差
            MinDf = new double[NL + 1];//Min各波長でのフォーカス誤差


            //Gn[1] = 52; aR[1] = 0;
            for (j = 1; j <= Nm; j++)
            {
                Gn[j] = Convert.ToInt32(myControl.dataGridView1.Rows[1 + j].Cells[1].Value);
                aR[j] = Convert.ToDouble(myControl.dataGridView1.Rows[1 + j].Cells[2].Value);
            }

            for (j = 1; j <= Nm; j++)
            {
                A1[j] = Convert.ToDouble(myControl2.dataGridView1.Rows[Gn[j]-1].Cells[2].Value);
                A2[j] = Convert.ToDouble(myControl2.dataGridView1.Rows[Gn[j] - 1].Cells[3].Value);
                A3[j] = Convert.ToDouble(myControl2.dataGridView1.Rows[Gn[j] - 1].Cells[4].Value);
                B1[j] = Convert.ToDouble(myControl2.dataGridView1.Rows[Gn[j] - 1].Cells[5].Value);
                B2[j] = Convert.ToDouble(myControl2.dataGridView1.Rows[Gn[j] - 1].Cells[6].Value);
                B3[j] = Convert.ToDouble(myControl2.dataGridView1.Rows[Gn[j] - 1].Cells[7].Value);
            }
        }


       
      

       



        private void MenuItem2_Click(object sender, RoutedEventArgs e)
        {
            if (BEdit1 || BEdit2)
            {
                System.Windows.MessageBox.Show("dataGridView1が編集中です！！");
            }
            else
            {
                int i; int j;
                int Jn = Convert.ToInt32(TextBox1.Text);
                int En = Convert.ToInt32(TextBox2.Text);

                myControl.SetUC();
                myControl2.SetUC2();

                String OutText = "Glass\r\n";
                OutText = OutText + "項目\t記号\t値\t単位\r\n";
                OutText = OutText + "構成ガラス種類\tNm\t" + TextBox1.Text + "\t整数\r\n";
                OutText = OutText + "定数表ガラス数\tNg\t" + TextBox2.Text + "\t整数\r\n";

                OutText = OutText + "波長分割数\tNL\t" + TextBox3.Text + "\t整数\n";
                OutText = OutText + "波長初期値\tLam1\t" + TextBox4.Text + "\tμm\r\n";
                OutText = OutText + "波長終了値\tLam2\t" + TextBox5.Text + "\tμm\r\n";
                OutText = OutText + "目標パワー\tPsi0\t" + TextBox6.Text + "\t1/mm\r\n";
                OutText = OutText + "曲率変化種類数\tNr\t" + TextBox7.Text + "\t整数\r\n";

                OutText = OutText + "負曲率制限値\tMinAR\t" + TextBox8.Text + "\t1/mm\r\n";



                OutText = OutText + "評価基本構成表\r\n";

                for (i = 0; i <= 2; i++) { OutText = OutText + myControl.dataGridView1.Columns[i].HeaderText + "\t"; }
                OutText = OutText + "\r\n";
                for (i = 0; i < Jn + 2; i++)
                {
                    for (j = 0; j <= 2; j++)
                    {
                        OutText = OutText + myControl.dataGridView1.Rows[i].Cells[j].Value + "\t";
                    }
                    OutText = OutText + "\r\n";
                }

                OutText = OutText + "光学ガラス定数表\r\n";
                for (i = 0; i <= 7; i++) { OutText = OutText + myControl2.dataGridView1.Columns[i].HeaderText + "\t"; }
                OutText = OutText + "\r\n";
                for (i = 0; i < En; i++)
                {
                    for (j = 0; j <= 7; j++)
                    {
                        OutText = OutText + myControl2.dataGridView1.Rows[i].Cells[j].Value + "\t";
                    }
                    OutText = OutText + "\r\n";
                }


                if (myControl.saveFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    using (StreamWriter outfile = new StreamWriter(myControl.saveFileDialog1.FileName))
                    {
                        outfile.Write(OutText);
                    }
                }
            }
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.WindowState = WindowState.Minimized;
            this.WindowState = WindowState.Normal;
        }

        private void MenuItem3_Click(object sender, RoutedEventArgs e)
        {
            int i; int j;
            String[,] HData = new String[11, 5];

            if (myControl.openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                using (Microsoft.VisualBasic.FileIO.TextFieldParser MyReader = new Microsoft.VisualBasic.FileIO.TextFieldParser(myControl.openFileDialog1.FileName))
                {
                    MyReader.TextFieldType = Microsoft.VisualBasic.FileIO.FieldType.Delimited;
                    MyReader.SetDelimiters("\t");
                    String[] currentRow;
                    for (i = 0; i < 11; i++)
                    {
                        currentRow = MyReader.ReadFields();
                        if (currentRow != null)
                        {
                            j = 0;
                            foreach (String currentField in currentRow)
                            {
                                HData[i, j] = currentField;
                                if (j < 4) { j = j + 1; }
                            }
                        }
                    }

                    if (HData[0, 0] == "Glass")
                    {
                        int Jn = Convert.ToInt32(HData[2, 2]);

                        String[,] RCData = new String[Jn + 4, 4];
                        for (i = 0; i < Jn + 4; i++)
                        {
                            currentRow = MyReader.ReadFields();
                            j = 0;
                            foreach (String currentField in currentRow)
                            {
                                RCData[i, j] = currentField;
                                if (j < 3) { j = j + 1; }
                            }
                        }

                        TextBox1.Text = HData[2, 2];
                        TextBox2.Text = HData[3, 2];
                        TextBox3.Text = HData[4, 2];
                        TextBox4.Text = HData[5, 2];
                        TextBox5.Text = HData[6, 2];
                        TextBox6.Text = HData[7, 2];
                        TextBox7.Text = HData[8, 2];
                        TextBox8.Text = HData[9, 2];



                        myControl.SetUC();
                        myControl2.SetUC2();


                        for (i = 0; i < Jn; i++)
                        {
                            for (j = 0; j < 3; j++)
                            {
                                myControl.dataGridView1.Rows[2 + i].Cells[j].Value = RCData[i + 3, j];
                            }
                        }

                        int En = Convert.ToInt32(HData[3, 2]);
                        String[,] RCData2 = new String[En + 2, 9];
                        for (i = 0; i <= En; i++)
                        {
                            currentRow = MyReader.ReadFields();
                            j = 0;
                            foreach (String currentField in currentRow)
                            {
                                RCData2[i, j] = currentField;
                                if (j < 8) { j = j + 1; }
                            }
                        }

                        for (i = 0; i <= En; i++)
                        {
                            for (j = 0; j < 8; j++)
                            {
                                myControl2.dataGridView1.Rows[i].Cells[j].Value = RCData2[i + 1, j];
                            }
                        }

                    }
                    else
                    {
                        System.Windows.MessageBox.Show("ファイル形式が異なります！！");
                    }
                }
            }
        }

       

       





    }
}
