﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Forms;


namespace Glass
{
    /// <summary>
    /// Window2.xaml の相互作用ロジック
    /// </summary>
    public partial class Window2 : Window
    {
        Color[] c = new Color[18];

        public Window2()
        {
            InitializeComponent();

        }



        private void Window_Loaded(object sender, RoutedEventArgs e)
        {

        }

        private void Button1_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        public void Draw(DataGridView dataGridView1)
        {
            String Me = (String)dataGridView1.Rows[0].Cells[1].Value;
            if (Me == "1") { Draw1(dataGridView1); }//1種類自動変更計算
            if (Me == "2") { Draw2(dataGridView1); }//材質固定計算
            if (Me == "3") { Draw3(dataGridView1); }//２種類自動変更計算
        }

        void Draw1(DataGridView dataGridView1)
        {
            int i,j;
            int Ng,NL;
            int n0 = 2;

            Ng = Convert.ToInt32(dataGridView1.Rows[1].Cells[1].Value);
            NL = Convert.ToInt32(dataGridView1.Rows[1].Cells[3].Value);

            double[,] array = new double[n0, NL+1];

            for (i = 0; i <= NL; i++)
            {
                array[0, i] = Convert.ToDouble(dataGridView1.Rows[8 + Ng + i].Cells[0].Value);
                array[1, i] = Convert.ToDouble(dataGridView1.Rows[8 + Ng + i].Cells[1].Value);
            }


            double[] max = new double[n0];
            double[] min = new double[n0];
            for (i = 0; i < n0; i++)
            {
                max[i] = -1e12;
                min[i] = 1e12;
                for (j = 0; j < NL+1; j++)
                {
                    if (array[i, j] > max[i]) { max[i] = array[i, j]; }
                    if (array[i, j] < min[i]) { min[i] = array[i, j]; }
                }
            }
            for (i = 0; i < n0; i++)
            {
                for (j = 0; j < NL+1; j++)
                {
                    array[i, j] = (array[i, j] - min[i]) / (max[i] - min[i]);
                }
            }

            TextBlock1.Text = "ガラスNo=" + dataGridView1.Rows[5 + Ng ].Cells[1].Value + "\r\n"
                + "ガラス型名=" + dataGridView1.Rows[6 + Ng].Cells[1].Value + "\r\n"
                + "波長Min=" + Convert.ToString(min[0]) + "μm\r\n"
                + "波長Max=" + Convert.ToString(max[0]) + "μm\r\n"
                + "focusMin=" + Convert.ToString(min[1]) + "mm\r\n"
                + "focusMax=" + Convert.ToString(max[1]) + "μm\r\n";
            SetMyC();
            graph(array, Grid1);
    
 
        }

        void graph(double[,] array, Grid Grid1)
        {
            int n0 = array.GetUpperBound(0) + 1;
            int n1 = array.GetUpperBound(1) + 1;

            Grid1.Children.Clear();
            double x0 = 150; double y0 = 350;
            int i; int j;
            for (i = 1; i < n0; i++)
            {
                PathFigure myPathFigure = new PathFigure();
                myPathFigure.StartPoint = new Point(x0, y0 - 300 * array[1, 0]);
                Path myPath = new Path();
                myPath.Stroke = new SolidColorBrush(c[i - 1]);
                myPath.StrokeThickness = 2;
                for (j = 0; j < n1; j++)
                {
                    myPathFigure.Segments.Add(new LineSegment(new Point(x0 + 400 * array[0, j], y0 - 300 * array[i, j]), true));
                }
                PathGeometry myPathGeometry = new PathGeometry();
                myPathGeometry.Figures.Add(myPathFigure);
                myPath.Data = myPathGeometry;
                Grid1.Children.Add(myPath);
            }
        }

        void SetMyC()
        {
            int i;
            for (i = 0; i < 3; i++)
            {
                c[i] = Color.FromArgb(255, Convert.ToByte(255 - 75 * i), 0, 0);
                c[i + 3] = Color.FromArgb(255, Convert.ToByte(150 - 40 * i), Convert.ToByte(150 - 40 * i), 0);
                c[i + 6] = Color.FromArgb(255, 0, Convert.ToByte(255 - 75 * i), 0);
                c[i + 9] = Color.FromArgb(255, 0, Convert.ToByte(150 - 40 * i), Convert.ToByte(150 - 40 * i));
                c[i + 12] = Color.FromArgb(255, 0, 0, Convert.ToByte(255 - 75 * i));
                c[i + 15] = Color.FromArgb(255, Convert.ToByte(150 - 40 * i), 0, Convert.ToByte(150 - 40 * i));
            }
        }




        void Draw2(DataGridView dataGridView1)
        {
            int i, j;
            int NL;
            int n0 = 2;

            NL = Convert.ToInt32(dataGridView1.Rows[0].Cells[3].Value);

            double[,] array = new double[n0, NL + 1];

            for (i = 0; i <= NL; i++)
            {
                array[0, i] = Convert.ToDouble(dataGridView1.Rows[7 + i].Cells[0].Value);
                array[1, i] = Convert.ToDouble(dataGridView1.Rows[7 + i].Cells[1].Value);
            }


            double[] max = new double[n0];
            double[] min = new double[n0];
            for (i = 0; i < n0; i++)
            {
                max[i] = -1e12;
                min[i] = 1e12;
                for (j = 0; j < NL + 1; j++)
                {
                    if (array[i, j] > max[i]) { max[i] = array[i, j]; }
                    if (array[i, j] < min[i]) { min[i] = array[i, j]; }
                }
            }
            for (i = 0; i < n0; i++)
            {
                for (j = 0; j < NL + 1; j++)
                {
                    array[i, j] = (array[i, j] - min[i]) / (max[i] - min[i]);
                }
            }

            TextBlock1.Text = "ガラスNo=" + dataGridView1.Rows[3].Cells[0].Value + "\r\n"
                + "ガラス型名=" + dataGridView1.Rows[3].Cells[1].Value + "\r\n"
                + "波長Min=" + Convert.ToString(min[0]) + "μm\r\n"
                + "波長Max=" + Convert.ToString(max[0]) + "μm\r\n"
                + "focusMin=" + Convert.ToString(min[1]) + "mm\r\n"
                + "focusMax=" + Convert.ToString(max[1]) + "μm\r\n";
            SetMyC();
            graph(array, Grid1);

        }


        void Draw3(DataGridView dataGridView1)
        {
            int i, j;
            int NL;
            int n0 = 2;

            NL = Convert.ToInt32(dataGridView1.Rows[0].Cells[3].Value);

            double[,] array = new double[n0, NL + 1];

            for (i = 0; i <= NL; i++)
            {
                array[0, i] = Convert.ToDouble(dataGridView1.Rows[7 + i].Cells[0].Value);
                array[1, i] = Convert.ToDouble(dataGridView1.Rows[7 + i].Cells[1].Value);
            }


            double[] max = new double[n0];
            double[] min = new double[n0];
            for (i = 0; i < n0; i++)
            {
                max[i] = -1e12;
                min[i] = 1e12;
                for (j = 0; j < NL + 1; j++)
                {
                    if (array[i, j] > max[i]) { max[i] = array[i, j]; }
                    if (array[i, j] < min[i]) { min[i] = array[i, j]; }
                }
            }
            for (i = 0; i < n0; i++)
            {
                for (j = 0; j < NL + 1; j++)
                {
                    array[i, j] = (array[i, j] - min[i]) / (max[i] - min[i]);
                }
            }

            TextBlock1.Text = "focus標準偏差=" + dataGridView1.Rows[1].Cells[1].Value + "\r\n"
                +"ガラスNo=" + dataGridView1.Rows[2].Cells[1].Value + "\r\n"
                + "ガラス型名=" + dataGridView1.Rows[3].Cells[1].Value + "\r\n"
                + "aR[1](1/mm)=" + dataGridView1.Rows[4].Cells[1].Value + "\r\n"

                + "ガラスNo=" + dataGridView1.Rows[2].Cells[2].Value + "\r\n"
                + "ガラス型名=" + dataGridView1.Rows[3].Cells[2].Value + "\r\n"
                + "aR[2](1/mm)=" + dataGridView1.Rows[4].Cells[2].Value + "\r\n"

                + "波長Min=" + Convert.ToString(min[0]) + "μm\r\n"
                + "波長Max=" + Convert.ToString(max[0]) + "μm\r\n"
                + "focusMin=" + Convert.ToString(min[1]) + "mm\r\n"
                + "focusMax=" + Convert.ToString(max[1]) + "μm\r\n";
            SetMyC();
            graph(array, Grid1);

        }






       




    }
}
